using System.Text;

namespace orchestrator_ui
{
    public partial class MainUI : Form
    {

        private string FileName;

        public MainUI()
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.ShowDialog();
            FileName = openFileDialog.FileName;
            if (!FileName.EndsWith(".settings"))
            {
                MessageBox.Show("Error! Only .settings file can be loaded");
                Application.Exit();
                return;
            }

            string[] lines = File.ReadAllLines(FileName);

            InitializeComponent();

            foreach (string line in lines)
            {
                listView1.Items.Add(line);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            bool isLiteral = literalBox.Checked;
            String entry = entryName.Text;
            String destination = destinationBox.Text;
            String source = sourceBox.Text;
            String mode = modeBox.Text;
            String extra = extraBox.Text;

            StringBuilder stringBuilder = new StringBuilder();
            if (isLiteral)
            {
                stringBuilder.Append("LITERAL ");
            }

            stringBuilder.Append(entry).Append(",").Append(destination).Append(",").Append(source).Append(",").Append(mode);

            if (extra.Trim().Length > 0)
            {
                stringBuilder.Append(" ").Append(extra);
            }

            listView1.Items.Add(stringBuilder.ToString());
        }


        private void saveButton_Click(object sender, EventArgs e)
        {
            List<String> list = new List<String>();
            foreach (ListViewItem item in listView1.Items)
            {
                list.Add(item.Text);
            }
            // abs
            File.WriteAllLines(FileName, list.ToArray());
        }

        private void delete()
        {
            foreach (ListViewItem eachItem in listView1.SelectedItems)
            {
                listView1.Items.Remove(eachItem);
            }
        }

        private void removeButton_Click(object sender, EventArgs e)
        {
            delete();
        }

        private void listView1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete)
            {
                delete();
            }
        }

        private void findButton_Click(object sender, EventArgs e)
        {
            SearchForm searchForm = new SearchForm();
            if(searchForm.ShowDialog() == DialogResult.OK)
            {
                string filter = searchForm.getFilter();
                listView1.SelectedItems.Clear();
                bool found = false;
                foreach (ListViewItem item in listView1.Items)
                {
                    if(item.Text.Contains(filter))
                    {
                        item.Selected = true;
                        listView1.Select();
                        found = true;
                    }
                }

                if(!found)
                {
                    MessageBox.Show("No entry found.");
                }

            }
        }
    }
}
